package com.community.huiju.security;

import com.community.huiju.exception.WisdomSecurityException;
import org.springframework.security.authentication.AuthenticationManager;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.AuthenticationException;
import org.springframework.security.web.authentication.preauth.PreAuthenticatedAuthenticationToken;
import org.springframework.stereotype.Component;

public class RestPreAuthenticateManager implements AuthenticationManager {

    @Override
    public Authentication authenticate(Authentication authentication) throws AuthenticationException {
        if (authentication instanceof PreAuthenticatedAuthenticationToken) {
            PreAuthenticatedAuthenticationToken preAuthrentication = (PreAuthenticatedAuthenticationToken) authentication;
            if (null != preAuthrentication.getAuthorities() && preAuthrentication.getAuthorities().size() > 0) {
                preAuthrentication.setAuthenticated(true);
                return preAuthrentication;
            }
        } else if (authentication instanceof  TokenAuthrentication) {
            TokenAuthrentication tokenAuthrentication = (TokenAuthrentication) authentication;
            if (null != tokenAuthrentication.getAuthorities() && tokenAuthrentication.getAuthorities().size() > 0) {
                tokenAuthrentication.setAuthenticated(true);
                return tokenAuthrentication;
            }
        }

        throw new WisdomSecurityException("没有授权角色!");
    }
}
