package com.community.huiju.security;

import com.community.huiju.exception.WisdomSecurityException;
import org.springframework.security.authentication.AuthenticationProvider;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.AuthenticationException;
import org.springframework.security.web.authentication.preauth.PreAuthenticatedAuthenticationToken;

/**
 * 授权过程
 * @author weiximei
 */
public class RestPreAuthenticateProvider implements AuthenticationProvider {

    @Override
    public Authentication authenticate(Authentication authentication) throws AuthenticationException {

        if (authentication instanceof  PreAuthenticatedAuthenticationToken) {
            PreAuthenticatedAuthenticationToken preAuthrentication = (PreAuthenticatedAuthenticationToken) authentication;
            if (null != preAuthrentication.getAuthorities() && preAuthrentication.getAuthorities().size() > 0) {
                preAuthrentication.setAuthenticated(true);
                return preAuthrentication;
            }
        } else if (authentication instanceof  TokenAuthrentication) {
            TokenAuthrentication tokenAuthrentication = (TokenAuthrentication) authentication;
            if (null != tokenAuthrentication.getAuthorities() && tokenAuthrentication.getAuthorities().size() > 0) {
                tokenAuthrentication.setAuthenticated(true);
                return tokenAuthrentication;
            }
        }

        throw new WisdomSecurityException("没有授权角色!");
    }

    /**
     * 是否授权过程
     * @param authentication
     * @return
     */
    @Override
    public boolean supports(Class<?> authentication) {
        return PreAuthenticatedAuthenticationToken.class.isAssignableFrom(authentication)
                || TokenAuthrentication.class.isAssignableFrom(authentication);
    }
}
